package notice.model.data;

import java.sql.SQLException;
import java.text.SimpleDateFormat;
import java.util.Date;
import java.util.Vector;
import java.sql.Connection;
import java.sql.PreparedStatement;
import java.sql.ResultSet;

import notice.model.object.NoticeInf;

import jp.co.intra_mart.foundation.service.client.information.Identifier;
import jp.co.intra_mart.framework.base.data.DAOException;
import jp.co.intra_mart.framework.base.data.LoginGroupDBDAO;


/**
 * fɃANZX邽߂intra-martDBDAO
 * 
 * @author NTTDATA intra-mart
 */
public class NoticeIntramartDBDAO
    extends LoginGroupDBDAO
    implements NoticeDAOIF {

    /**
     * ftHgRXgN^
     */
    public NoticeIntramartDBDAO() {
        super();
    }
    
    //SQL`
    private final String SQL_INSERT = "INSERT INTO tutorial_plus_notice " +
        "(notice_cd,title,author,record_date,content) VALUES (?,?,?,?,?)";
        
    private final String SQL_SELECT = "SELECT notice_cd,title,author,record_date,content" +
        " FROM tutorial_plus_notice ORDER BY record_date ";
        

    /**
     * fo^܂
     * @see notice.model.data.NoticeDAOIF#insert(NoticeInf)
     * @param notice f
     */
    public void insert(NoticeInf notice) throws DAOException {
        Connection con = null;
        PreparedStatement stmt = null;
        String noticeCd;
        SimpleDateFormat sdf = new SimpleDateFormat("yyyy/MM/dd|HH:mm:ss");
        String registDate = sdf.format(notice.getRegistDate());
        
        
        if(notice == null){
            return;
        }
        
        //DbsConnection̎擾
        try{
            con = getConnection();
        } catch(Exception e){
            throw new DAOException(e.getMessage(), e);
        }
        
        // fR[h̎擾
        noticeCd = Identifier.make();
            
        //insert
        try{
            stmt = con.prepareStatement(SQL_INSERT);
            stmt.setString(1,noticeCd);
            stmt.setString(2,notice.getTitle());
            stmt.setString(3,notice.getAuthor());
            stmt.setString(4,registDate);
            stmt.setString(5,notice.getContent());
            stmt.executeUpdate();
        }catch(SQLException e){
            throw new DAOException(e.getMessage(), e);
        } finally {
            try{
                if(stmt != null){
                    stmt.close();
                }
            } catch (SQLException e){
            }
        }
    }

    /**
     * f擾܂
     * @see notice.model.data.NoticeDAOIF#insert(NoticeInf)
     * @return f
     */    
    public Vector select() throws DAOException{
        int i;
        Connection con = null;
        PreparedStatement stmt = null;
        ResultSet result = null;
        Vector notices = new Vector();    
        SimpleDateFormat sdf = new SimpleDateFormat("yyyy/MM/dd|HH:mm:ss");
        
        //Connection̎擾
        try{
            con = getConnection();
        } catch(Exception e){
            throw new DAOException(e.getMessage(), e);
        }
        
        //SQLs
        try{
            stmt = con.prepareStatement(SQL_SELECT);
            result = stmt.executeQuery();
            
            while (result.next()) {
                NoticeInf notice = new NoticeInf();
                Date recordDate = new Date();
                notice.setTitle(result.getString("title"));
                notice.setAuthor(result.getString("author"));
                notice.setRegistDate(sdf.parse(result.getString("record_date")));
                notice.setContent(result.getString("content"));
                
                notices.add(notice);
            }
            
        } catch(Exception e){
            throw new DAOException(e.getMessage(), e);
        } finally {
            try{
                if(result != null){
                    result.close();
                }
                if(stmt != null){
                    stmt.close();
                }
            } catch (SQLException e){
            }
        }
        
        //ff[^ԋp
        return notices;

    }

}
